------------------------------------------------------------------------------
--                                                                          --
--                          GNATCHECK COMPONENTS                            --
--                                                                          --
--                 A S I S _ U L . E N V I R O N M E N T .                  --
--       T O O L_ S P E C I F I C _ I N I T I A L I Z A T I O N _ 1         --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--                     Copyright (C) 2004-2005, AdaCore                     --
--                                                                          --
-- GNATCHECK  is  free  software;  you can redistribute it and/or modify it --
-- under terms of the  GNU  General Public License as published by the Free --
-- Software Foundation;  either version 2, or ( at your option)  any  later --
-- version.  GNATCHECK  is  distributed in the hope that it will be useful, --
-- but  WITHOUT  ANY  WARRANTY;   without  even  the  implied  warranty  of --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General --
-- Public License for more details.  You should have received a copy of the --
-- GNU  General Public License distributed with GNAT; see file  COPYING. If --
-- not,  write to the  Free Software Foundation,  51 Franklin Street, Fifth --
-- Floor, Boston, MA 02110-1301, USA.                                       --
--                                                                          --
-- GNATCHECK is maintained by AdaCore (http://www.adacore.com).             --
--                                                                          --
------------------------------------------------------------------------------

--  Here all the calls to Gnatcheck.Rules.Register_Rule for all the rules
--  currently implemented in gnatcheck should be placed

with Gnatcheck.Rules;         use Gnatcheck.Rules;
with Gnatcheck.Rules.Default; use Gnatcheck.Rules.Default;

separate (ASIS_UL.Environment)
procedure Tool_Specific_Initialization_1 is
begin
   Register_Rule (Abstr_Types_Rule                  'Access);
   Register_Rule (Anonymous_Subtypes_Rule           'Access);
   Register_Rule (Blocks_Rule                       'Access);
   Register_Rule (Bool_Relation_Ops_Rule            'Access);
   Register_Rule (Ceiling_Pr_Consistency_Rule       'Access);
   Register_Rule (Contr_Types_Rule                  'Access);
   Register_Rule (Decl_Blocks_Rule                  'Access);
   Register_Rule (Default_Par_Rule                  'Access);
   Register_Rule (Derived_Types_Rule                'Access);
   Register_Rule (Discr_Rec_Rule                    'Access);
   Register_Rule (Float_Equality_Checks_Rule        'Access);
   Register_Rule (Global_Loop_Exit_Rule             'Access);
   Register_Rule (Goto_Rule                         'Access);
   Register_Rule (LL_Subpr_Rule                     'Access);
   Register_Rule (Local_Pckg_Rule                   'Access);
   Register_Rule (Max_Calls_To_PO_Entry_Rule        'Access);
   Register_Rule (One_Entry_In_PO_Rule              'Access);
   Register_Rule (Overloaded_Operators_Rule         'Access);
   Register_Rule (Proper_Returns_Rule               'Access);
   Register_Rule (Qualified_Aggr_Rule               'Access);
   Register_Rule (Recursion_Rule                    'Access);
   Register_Rule (Restrict_Name_Space_Rule          'Access);
   Register_Rule (Side_Effect_Functions_Rule        'Access);
   Register_Rule (Simple_Loop_Exit_Names_Rule       'Access);
   Register_Rule (Slices_Rule                       'Access);
   Register_Rule (Spark_Attributes_Rule             'Access);
   Register_Rule (Unconstr_Array_Return_Rule        'Access);
   Register_Rule (Universal_Ranges_Rule             'Access);
   Register_Rule (Unused_Subpr_Rule                 'Access);
   Register_Rule (Use_Pckg_Clauses_Rule             'Access);
   Register_Rule (Volatile_Requires_Addr_Clause_Rule'Access);
end Tool_Specific_Initialization_1;
